﻿/*
 * 文件: DateTimeExtension.cs
 * 由SharpDevelop创建。
 * 作者: gwang
 * 
 * 功能: 描述
 * 版本:
 *     1.0.0 Created by gwang - 2016/6/25 14:44 
 */
using System;

namespace CSharpUtil.Extensions.Time
{

    /// <summary>
    /// Description of DateTimeExtension.
    /// </summary>
    static public class DateTimeExtension
    {
        #region `    扩展DateTime功能,增加Unix时间戳扩展    `
        /// <summary>
        /// 从DateTime获取Unix时间戳(按照当前时区换算过了)
        /// </summary>
        /// <param name="dt"></param>
        /// <returns></returns>
        public static UInt32 ToUnixTimeStamp(this DateTime dt)
        {
            return (UInt32)((dt.ToUniversalTime().Ticks - 621355968000000000) / 10000000);
        }
        /// <summary>
        /// Unix时间戳转DateTime(已经自动转换到当前时区了)
        /// </summary>
        /// <param name="dt"></param>
        /// <param name="uiStamp"></param>
        /// <returns></returns>
        public static DateTime FromUnixStamp(this DateTime dt, UInt32 uiStamp)
        {
            return TimeZone.CurrentTimeZone.ToLocalTime(new DateTime(1970, 1, 1)).AddSeconds(uiStamp);
        }

        /**
      *  返回自从 Unix 纪元（格林威治时间 1970 年 1 月 1 日 00:00:00）到当前时间的天数。
      * 检测玩家连续登录及隔天刷新操作用
      * @param type $time 当前时间戳
      * @return type
      */
        public static int tsDay(this DateTime dt)
        {
            return (int)((dt.ToUnixTimeStamp() + 28800) / 86400f); // 东八区前提8小时时差
        }
        #endregion
    }


}